<?php
/**
 * CalculateForCheckoutRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\MarketingClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi. Marketing.
 *
 * Маркетинг
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\MarketingClient\Dto;

use \ArrayAccess;
use \Ensi\MarketingClient\ObjectSerializer;

/**
 * CalculateForCheckoutRequest Class Doc Comment
 *
 * @category Class
 * @package  Ensi\MarketingClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class CalculateForCheckoutRequest implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'CalculateForCheckoutRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'offers' => '\Ensi\MarketingClient\Dto\DiscountOfferCheckoutRequest[]',
        'customer' => '\Ensi\MarketingClient\Dto\CalculateForCheckoutRequestCustomer',
        'deliveries' => '\Ensi\MarketingClient\Dto\CalculateForCheckoutRequestDeliveries[]',
        'payment' => '\Ensi\MarketingClient\Dto\CalculateForCheckoutRequestPayment',
        'promo_code' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'offers' => null,
        'customer' => null,
        'deliveries' => null,
        'payment' => null,
        'promo_code' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'offers' => false,
        'customer' => false,
        'deliveries' => false,
        'payment' => false,
        'promo_code' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'offers' => 'offers',
        'customer' => 'customer',
        'deliveries' => 'deliveries',
        'payment' => 'payment',
        'promo_code' => 'promoCode'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'offers' => 'setOffers',
        'customer' => 'setCustomer',
        'deliveries' => 'setDeliveries',
        'payment' => 'setPayment',
        'promo_code' => 'setPromoCode'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'offers' => 'getOffers',
        'customer' => 'getCustomer',
        'deliveries' => 'getDeliveries',
        'payment' => 'getPayment',
        'promo_code' => 'getPromoCode'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('offers', $data, null);
        $this->setIfExists('customer', $data, null);
        $this->setIfExists('deliveries', $data, null);
        $this->setIfExists('payment', $data, null);
        $this->setIfExists('promo_code', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['offers'] === null) {
            $invalidProperties[] = "'offers' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets offers
     *
     * @return \Ensi\MarketingClient\Dto\DiscountOfferCheckoutRequest[]
     */
    public function getOffers()
    {
        return $this->container['offers'];
    }

    /**
     * Sets offers
     *
     * @param \Ensi\MarketingClient\Dto\DiscountOfferCheckoutRequest[] $offers offers
     *
     * @return $this
     */
    public function setOffers($offers)
    {


        /*if (is_null($offers)) {
            throw new \InvalidArgumentException('non-nullable offers cannot be null');
        }*/
        $this->container['offers'] = $offers;

        return $this;
    }

    /**
     * Gets customer
     *
     * @return \Ensi\MarketingClient\Dto\CalculateForCheckoutRequestCustomer|null
     */
    public function getCustomer()
    {
        return $this->container['customer'];
    }

    /**
     * Sets customer
     *
     * @param \Ensi\MarketingClient\Dto\CalculateForCheckoutRequestCustomer|null $customer customer
     *
     * @return $this
     */
    public function setCustomer($customer)
    {


        /*if (is_null($customer)) {
            throw new \InvalidArgumentException('non-nullable customer cannot be null');
        }*/
        $this->container['customer'] = $customer;

        return $this;
    }

    /**
     * Gets deliveries
     *
     * @return \Ensi\MarketingClient\Dto\CalculateForCheckoutRequestDeliveries[]|null
     */
    public function getDeliveries()
    {
        return $this->container['deliveries'];
    }

    /**
     * Sets deliveries
     *
     * @param \Ensi\MarketingClient\Dto\CalculateForCheckoutRequestDeliveries[]|null $deliveries deliveries
     *
     * @return $this
     */
    public function setDeliveries($deliveries)
    {


        /*if (is_null($deliveries)) {
            throw new \InvalidArgumentException('non-nullable deliveries cannot be null');
        }*/
        $this->container['deliveries'] = $deliveries;

        return $this;
    }

    /**
     * Gets payment
     *
     * @return \Ensi\MarketingClient\Dto\CalculateForCheckoutRequestPayment|null
     */
    public function getPayment()
    {
        return $this->container['payment'];
    }

    /**
     * Sets payment
     *
     * @param \Ensi\MarketingClient\Dto\CalculateForCheckoutRequestPayment|null $payment payment
     *
     * @return $this
     */
    public function setPayment($payment)
    {


        /*if (is_null($payment)) {
            throw new \InvalidArgumentException('non-nullable payment cannot be null');
        }*/
        $this->container['payment'] = $payment;

        return $this;
    }

    /**
     * Gets promo_code
     *
     * @return string|null
     */
    public function getPromoCode()
    {
        return $this->container['promo_code'];
    }

    /**
     * Sets promo_code
     *
     * @param string|null $promo_code Промокод
     *
     * @return $this
     */
    public function setPromoCode($promo_code)
    {


        /*if (is_null($promo_code)) {
            throw new \InvalidArgumentException('non-nullable promo_code cannot be null');
        }*/
        $this->container['promo_code'] = $promo_code;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


